Bug 1060502 - Review Request: golang-github-mitchellh-cli - A library for implementing powerful command-line interfaces in Go
Summary: Review Request: golang-github-mitchellh-cli - A library for implementing powe...
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Lubomir Rintel
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 1212318
TreeView+ depends on / blocked
 
Reported: 2014-02-02 04:40 UTC by Jeff Schroeder
Modified: 2017-06-15 09:21 UTC (History)
8 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2017-06-15 03:00:35 UTC
lkundrak: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Jeff Schroeder 2014-02-02 04:40:02 UTC
Spec URL: http://www.digitalprognosis.com/opensource/packages/golang-github-mitchellh-cli/golang-github-mitchellh-cli.spec
SRPM URL: http://www.digitalprognosis.com/opensource/packages/golang-github-mitchellh-cli/golang-github-mitchellh-cli-0-0.1.git69f0b65ce53b.fc20.src.rpm

Description:
This (cli) is the library that powers the CLI for Packer
(https://github.com/mitchellh/packer) and Serf
(https://github.com/hashicorp/serf).

Fedora Account System Username: sejeff

[jeff@omniscience SPECS]$ rpmlint  golang-github-mitchellh-cli.spec ../SRPMS/golang-github-mitchellh-cli-0-0.1.git69f0b65ce53b.fc20.src.rpm ../RPMS/golang-github-mitchellh-cli-devel-0-0.1.git69f0b65ce53b.fc20.noarch.rpm
2 packages and 1 specfiles checked; 0 errors, 0 warnings.

Koji also seems happy: http://koji.fedoraproject.org/koji/taskinfo?taskID=6480481

Comment 1 Dan Mashal 2014-02-27 23:15:32 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[ ]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 16 files have unknown license. Detailed output of
     licensecheck in /home/dan/fedora-review/1060502-golang-github-mitchellh-
     cli/licensecheck.txt
[ ]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/share/gocode/src(golang-
     github-gorilla-mux-devel, golang-googlecode-net-devel, golang-googlecode-
     goprotobuf-devel, golang-github-coreos-go-systemd-devel, golang-
     googlecode-sqlite-devel, golang-bitbucket-kardianos-osext-devel, golang-
     github-gorilla-context-devel, golang-github-coreos-go-log-devel, golang-
     github-kr-pty-devel, golang-github-goraft-raft-devel), /usr/share/gocode
     (golang-github-gorilla-mux-devel, golang-googlecode-net-devel, golang-
     googlecode-goprotobuf-devel, golang-github-coreos-go-systemd-devel,
     golang-googlecode-sqlite-devel, golang-bitbucket-kardianos-osext-devel,
     golang-github-gorilla-context-devel, golang-github-coreos-go-log-devel,
     golang-github-kr-pty-devel, golang-github-goraft-raft-devel),
     /usr/share/gocode/src/github.com(golang-github-gorilla-mux-devel, golang-
     github-syndtr-gocapability-devel, golang-github-coreos-go-systemd-devel,
     golang-github-gorilla-context-devel, golang-github-coreos-go-log-devel,
     golang-github-kr-pty-devel, golang-github-goraft-raft-devel)
[ ]: Package contains no bundled libraries without FPC exception.
[ ]: Changelog in prescribed format.
[ ]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package uses nothing in %doc for runtime.
[ ]: Package consistently uses macros (instead of hard-coded directory names).
[ ]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[ ]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[ ]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: golang-github-mitchellh-cli-devel-0-0.1.git69f0b65ce53b.fc20.noarch.rpm
          golang-github-mitchellh-cli-0-0.1.git69f0b65ce53b.fc20.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint golang-github-mitchellh-cli-devel
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
golang-github-mitchellh-cli-devel (rpmlib, GLIBC filtered):
    golang



Provides
--------
golang-github-mitchellh-cli-devel:
    golang(github.com/mitchellh/cli)
    golang-github-mitchellh-cli-devel



Source checksums
----------------
https://github.com/mitchellh/cli/tarball/master/mitchellh-cli-69f0b65.tar.gz :
  CHECKSUM(SHA256) this package     : 469e50e09a5dbf7554ca90376be928c10a2e41c871c61ed5cf0fe31d6d14576b
  CHECKSUM(SHA256) upstream package : 469e50e09a5dbf7554ca90376be928c10a2e41c871c61ed5cf0fe31d6d14576b


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1060502
Buildroot used: fedora-20-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 2 Lokesh Mandvekar 2014-02-28 04:16:23 UTC
Hi Jeff,

I'm not sure if the noarch for rhel >= 7 would work right now. Last time I checked, stuff was failing for some arch for rhel7 (I think ppc64). So I had noarch only for fedora >= 19.

Did 'go test' work for you without specifying GOPATH? IIRC, it failed for me sometime back, and I used this: GOPATH=%{buildroot}/%{gopath} go test %{import_path}/capability 
(line 45 http://pkgs.fedoraproject.org/cgit/golang-github-syndtr-gocapability.git/tree/golang-github-syndtr-gocapability.spec)

some minor things to consider (no biggie), for upstreams using git I've used 'shortcommit' (http://pkgs.fedoraproject.org/cgit/golang-github-gorilla-context.git/tree/golang-github-gorilla-context.spec) and for those using hg I've used 'shortrev' (http://pkgs.fedoraproject.org/cgit/golang-bitbucket-kardianos-osext.git/tree/golang-bitbucket-kardianos-osext.spec).

The shortrev and abbrevrev could perhaps be replaced with a single shortcommit here and it could be used in the release tag too. (Again, this is just the current state of existing golang-* packages and _not_ a guideline.).

HTH

Comment 3 Peter Lemenkov 2014-03-13 11:29:13 UTC
Removing FE-NEEDSPONSOR - I've just sponsored Jeff.

Comment 4 Lubomir Rintel 2014-05-14 11:12:23 UTC
The above review makes sense. Just some random extra things I've verified 
manually:
  
* Package is named correctly
* The version tag makes sense
* License tag is correct
* License is fine
* License text included
* rpmlint is happy
* SPEC file is clean and legible
 
Nothing severe really stands out; basically a couple of style issues:
 
0.) The description is a bit weird: Please do not repeat the summary and omit  
the hyperlinks. 
 
%description 
This (cli) is the library for implementing powerful command-line        
interfaces in Go. It's used by Self and Packer.
 
%description devel
This package contains the library for implementing powerful command-line
interfaces in Go. It's intended for building other packages which use these
functions.
 
1.) Please move BuildRequires ourside %package section.
 
2.) The package should always be noarch.
 
It only ships architecture-independent files. See [1]

[1] https://fedoraproject.org/wiki/Packaging:Guidelines#Noarch_with_unported_dependencies
 
-%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
-BuildArch:      noarch
-%else
-ExclusiveArch:  %{ix86} x86_64 %{arm}
-%endif
+BuildArch:      noarch
+%if 0%{?fedora} < 19 && 0%{?rhel} < 7
+ExclusiveArch:  %{ix86} x86_64 %{arm} noarch
+%endif
 
 
3.) No need for the %attr macro; install files with correct mode in %install. 
You won't need to list the whole hierarchy too.
 
-%dir %attr(755,root,root) %{gopath}
-%dir %attr(755,root,root) %{gopath}/src
-%dir %attr(755,root,root) %{gopath}/src/github.com
-%dir %attr(755,root,root) %{gopath}/src/github.com/mitchellh
-%dir %attr(755,root,root) %{gopath}/src/%{import_path}
-%attr(644,root,root) %{gopath}/src/%{import_path}/*.go
+%{gopath}

Comment 5 Jeff Schroeder 2014-05-25 02:53:41 UTC
Thanks for the help, I've addressed (I believe) all comments:

[jeff@omniscience SPECS] (master)$ rpmlint golang-github-mitchellh-cli.spec ../SRPMS/golang-github-mitchellh-cli-0-0.1.git69f0b65.fc20.src.rpm ../RPMS/golang-github-mitchellh-cli-devel-0-0.1.git69f0b65.fc20.noarch.rpm

Scratch build in koji looks good:
https://koji.fedoraproject.org/koji/taskinfo?taskID=6887559

Updated Version:
http://www.digitalprognosis.com/opensource/packages/golang-github-mitchellh-cli/golang-github-mitchellh-cli.spec
http://www.digitalprognosis.com/opensource/packages/golang-github-mitchellh-cli/golang-github-mitchellh-cli-0-0.1.git69f0b65.fc20.src.rpm

Comment 6 Lubomir Rintel 2014-05-25 08:15:50 UTC
Seems all fine to me now. Thank you!

APPROVED

Comment 7 Jeff Schroeder 2014-06-06 01:30:30 UTC
New Package SCM Request
=======================
Package Name: golang-github-mitchellh-cli
Short Description: A library for implementing powerful command-line interfaces in Go
Upstream URL: https://github.com/mitchellh/cli
Owners: sejeff
Branches: f19 f20 el6 epel7
InitialCC:

Comment 8 Gwyn Ciesla 2014-06-06 12:14:31 UTC
Git done (by process-git-requests).

Comment 9 Jan Chaloupka 2014-10-23 10:00:48 UTC
Hello. I am checking all golang packages from github. Just noticed this package has git done but there is no spec file committed so far.

Comment 10 Ed Marshall 2017-03-05 04:45:59 UTC
It looks like this got pushed into Fedora as the name "golang-githu-mitchellh-cli-temporary" instead of the proper name, and without any provides (so it won't get picked up by a properly-configured package, only by something that explicitly pulls it in).

So, uh...what happened? :)

Comment 11 Jan Chaloupka 2017-03-06 08:41:27 UTC
It is a temporary rpm. I don't have permissions to push to and build golang-github-mitchellh-cli. Once the real package gets build, I will remove the temporary one. Think, you could approve my request for permissions [1]?

[1] https://admin.fedoraproject.org/pkgdb/package/rpms/golang-github-mitchellh-cli/

Comment 12 Ed Marshall 2017-03-07 07:10:51 UTC
I would if I could, but I think only sejeff (or a provenpackager?) will be able to do that?

Comment 13 Jan Chaloupka 2017-03-07 11:17:43 UTC
I have contacted Jeff three times already asking for the permissions. Sadly, I have not been able to get them.

Comment 14 Jeff Schroeder 2017-03-07 15:22:48 UTC
How do I give you permissions? I don't recall you contacting me anytime recently, but recall you asking once and me saying sure go nuts. I'll have to redo my FAS credentials but how do I give you access? I never pushed anything to Fedora.

Comment 15 Jan Chaloupka 2017-03-07 17:42:28 UTC
About a year ago? :) I don't recall it clearly.

Should be enough to go here https://admin.fedoraproject.org/pkgdb/package/rpms/golang-github-mitchellh-cli/, client on "Manage the admins", set line with my name to "Approve" and "Apply Changes".

Thanks

Comment 16 Jeff Schroeder 2017-05-17 02:58:34 UTC
Jan, you've been added as an admin for this package. Sorry I suck so bad at life sometimes.

Comment 17 Fedora Update System 2017-05-18 12:09:16 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-a52932d849

Comment 18 Fedora Update System 2017-05-18 12:09:29 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-a7cb11f013

Comment 19 Fedora Update System 2017-05-18 12:09:37 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-b9b083b689

Comment 20 Fedora Update System 2017-05-18 12:09:44 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-87dd824e11

Comment 21 Jan Chaloupka 2017-05-18 12:20:20 UTC
Thanks for the permission Jeff. This is something of a low priority so I was not in hurry.

Comment 22 Fedora Update System 2017-05-18 19:04:55 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-b9b083b689

Comment 23 Fedora Update System 2017-05-18 21:23:25 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-a7cb11f013

Comment 24 Fedora Update System 2017-05-18 23:30:52 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-87dd824e11

Comment 25 Fedora Update System 2017-05-18 23:35:59 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-a52932d849

Comment 26 Fedora Update System 2017-06-15 03:00:35 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 27 Fedora Update System 2017-06-15 04:49:15 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.

Comment 28 Fedora Update System 2017-06-15 08:20:23 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 29 Fedora Update System 2017-06-15 09:21:46 UTC
golang-github-mitchellh-cli-0-0.1.git8102d0e.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.